@echo OFF
set bar_=---------------------------------
set NextCheck=SR32
set libtype=cxpos
set libfiles=cxglobal chpos cxpos getOpts QuoteStr fileScan OrdNums fdirfunc acconsts
set ConsoleApp=-CC
goto @Library_BuildCheck


:@@ErrLibNotExists
echo.
echo ~ Error! One or more required %lib% library is not exist
echo ~ Can not build Demo Applications
goto @Aborted

:@@ErrBuildCheck
::echo.
echo ~ Error! missing or invalid %DemoApp% demo files
echo ~ Can not build %Title% demo
echo.
pause
if not "%NextCheck%"=="" goto @%NextCheck%_BuildCheck
goto @Aborted

:@Aborted
echo.
echo ~ Some of buildings are cancelled.
goto @CleanUpDCUs


:@BeginBuild
echo.
echo %bar_%%bar_%
echo - Building %Title% demo. Please wait...
echo.
for %%e in (dpr cfg dof) do if not exist demos\%DemoApp%\%DemoApp%.%%e goto @@ErrBuildCheck
::
cd demos\%DemoApp%
dcc32 %D_OVR% %DemoApp%.dpr
cd   ..\..
echo.
echo - Done building %Title% demo.
echo %bar_%%bar_%
::EndSearchReplaceBuild
if not "%NextCheck%"=="" goto @%NextCheck%_BuildCheck
goto @CleanUpDCUs
:@EndBuild


:@Library_BuildCheck
set libexist=TRUE
::for %%f in (CxGlobal, chpos, cxpos, GetOpts, QuoteStr, FileScan, OrdNums, fDirFunc) do if not exist lib\cxpos.lib\%%f.pas echo unit %%f is not found
::for %%f in (CxGlobal, chpos, cxpos, GetOpts, QuoteStr, FileScan, OrdNums, fDirFunc) do if not exist lib\cxpos.lib\%%f.pas set libexist=
for %%f in (%libfiles%) do if not exist lib\%libtype%.lib\%%f.pas echo unit %%f is not found
for %%f in (%libfiles%) do if not exist lib\%libtype%.lib\%%f.pas set libexist=
set libtype=
set libfiles=
if not "%libexist%"=="TRUE" goto @@ErrLibNotExists
set libexist=
set D_OVR=%ConsoleApp% -$C- -$D- -$R- -b -q -n
goto @%NextCheck%_BuildCheck


:@SR32_BuildCheck
set Title="Search & Replace (file-patcher)"
set DemoApp=%NextCheck%
set NextCheck=ScanStr
goto @BeginBuild

:@ScanStr_BuildCheck
set Title="String-Scanner"
set DemoApp=%NextCheck%
set NextCheck=Pretty
goto @BeginBuild

:@Pretty_BuildCheck
set Title="Filename Pretty Formatter"
set DemoApp=%NextCheck%
set NextCheck=OtherLib
goto @BeginBuild

::need check Others' libs to build SpeedTest
:@OtherLib_BuildCheck
set NextCheck=SpeedTest
set libtype=Others
set libfiles=Searches mwTSearch FastStrings FastStringFuncs
set ConsoleApp=
goto @Library_BuildCheck

:@SpeedTest_BuildCheck
set Title="Speed Test Comparison"
set DemoApp=%NextCheck%
set NextCheck=
goto @BeginBuild


:@CleanUpDCUs
echo.
echo - Cleaning up DCU's...
if "OS"=="Windows_NT" goto @CleanUpWinNT

:@CleanUpWin9X
for %%u in (demos\SR32\*.dcu demos\ScanStr\*.dcu demos\Pretty\*.dcu demos\SpeedTest\*.dcu) do del %%u
for %%u in (lib\cxpos.lib\*.dcu lib\Others.lib\*.dcu) do del %%u
goto @DoneBuilding

:@CleanUpWinNT
::del *.dcu /s { disastrous command if executed under ($DELPHI) path :) }
goto @CleanUpWin9X
goto @DoneBuilding

:@DoneBuilding
echo - Building process all done.
echo %bar_%%bar_%
goto @End

:@End
for %%v in (bar_ NextCheck DemoApp Title D_OVR ConsoleApp) do set %%v=
echo.
